package provide glue 0.8

package require properties
package require hooks
package require helper

set ::loaded_modules [list]

proc DefaultProperties {} {
	property *|Alias {-type string -default unknown -save change}
	property *|Rename {-type action -name Rename -weight 97 }
	property *|Delete {-type action -name Delete -weight 98 }
	property Global|Exit {-type action -weight 99 -name Exit }
	property Contact:*|Groups [list -type list -default [nil] -save change]
	property Group:*|Groups	[list -type list -default [nil] -save change]
	
	after idle {bind Alicq <Destroy> {Event Global|Exit }}
}


proc AddObject {type name} {
	switch $type {
		group {Group [clock seconds] $name}
		contact {Event AddICQContact $name {other} $name}
	}
}

# Startup file commands
proc Module {name} {
	if {[lsearch $::loaded_modules $name]!=-1} return
	foreach item $::MODULES {
		set fname [file join $item $name]	
		if {[file exists $fname]} break
	}
	if {[file exists $fname]} {
		Log 5 "Module $name found ($fname)"
	} else {
		Log 5 "Module $name not found"
		return
	}
	set ns ::[file rootname $name]
	#source $fname; return
	if {[catch { namespace eval $ns [list source $fname] } Val]} {
		 Log 0 "Error loading module $name: $Val"
	} else { 
		Log 1 "Loaded module \"$name\""
		lappend ::loaded_modules $name
		Event ModuleLoaded $name
	}
}

proc Contact {uin alias groups {properties {}}} {
	Setter Contact:ICQ:$uin $properties \
		[list Alias $alias Groups [map gr $groups {set _ Group:common:$gr}] ]
}
proc Group {gid alias {groups {}} {properties {}}} { 
	Setter Group:common:$gid $properties [list Alias $alias Groups [map gr $groups {set _ Group:common:$gr}] ]
}

proc Setter {id plist list} {
	foreach item $plist {
		foreach {key val} [split $item =] break
		lappend list $key $val
	}
	foreach {key value} $list {
		property::Set $id|$key $value
	}
}

DefaultProperties

