#  Alicq ICQ client basic user interface module
#  Copyright (C) Ihar Viarheichyk 2001

#  This module is a part of Alicq ICQ client.

set confirmSilent 0
set confirmDump 0

proc MyDraw {path} { 
	_draw_tree_old $path
	#set im [.tr.c create image 0 0 -anchor nw -image [Bitmap::get /usr/share/pixmaps/Snail.xpm]]
	#.tr.c lower $im
}

proc DefaultTheme {} {
	foreach {item value} { 
		Button.relief	groove	Entry.relief groove
		Text.relief	groove	Entry.background gray90
		Text.background gray90	Frame*Menubutton.background gray90
		Tree.showlines	no	
		Frame.Menubutton.relief groove
		incomingColor	darkMagenta
		outgoingColor	darkBlue } {
		option add *$item $value widgetDefault						
	}
	# Default keybindings
	event add <<Hide-Offline>> <Control-o>
	event add <<Hide-Empty>> <Control-i>
	event add <<Send>> <Control-Return>
	event add <<Cite>> <Control-c>
	event add <<Close>> <Escape>
	event add <<Accept>> <Return>
	event add <<Context-Menu>> <3> <Control-1>
	event add <<Item-Activate>> <Double-1> <Return>
}

handler Error:Module {handler reason} {
	if {[llength [info procs $handler]]} {
		set handler [info body $handler]
	}
	GenericError {in one of the event handlers} $handler $reason {}
}
handler Error:Protocol {handler reason dump args} {
	GenericError {while handling ICQ protocol packet} $handler $reason $dump
}

proc GenericError {where handler reason dump} {
	variable confirmSilent
	variable confirmDump
	if {$confirmSilent || [catch {toplevel .error}]} return
	wm title .error "Alicq internal error"
	set text "An error occured $where:\n\n"
	append text "$reason\n in handler $handler\n"
	append text {
The error is not fatal, you can continue work.

You can report this error to author, if you want.
}
	if {$dump!={}} { append text {
Optionally you can also attach packet dump to 
your bug report.

Warning: packet dump can contain confidential message 
from person in your contact list.
}
	}
	label .error.info -relief groove -text $text
	grid .error.info -sticky new -padx 10 -pady 4
	if {$dump!={}} {
		checkbutton .error.cb -text {Attach protocol packet dump}\
			-variable [namespace current]::confirmDump
		grid .error.cb -sticky w -padx 20 -pady 5
	}
	checkbutton .error.again -text {Do not show this window again}\
		-variable [namespace current]::confirmSilent
	grid .error.again -sticky w -padx 20 -pady 5
	frame .error.b -bd 2 -relief groove
	button .error.b.close -text {Close} -command {destroy .error}
	button .error.b.report -text {Report a bug to author} -command\
		[list [namespace current]::report $handler $reason $dump]
	grid .error.b -sticky ew -pady 5 -padx 20
	grid .error.b.report .error.b.close -padx 20 -pady 4
}

proc report {handler reason dump} {
	variable confirmDump
	set msg "--- Automatical Bug Report ---\n"
	append msg "Handler: $handler\nReason: $reason\n\n"
	if {$confirmDump} {
		binary scan $dump H* hex
		append msg $hex
	}
	Event Outgoing text Contact:ICQ:47298730 $msg
	destroy .error
}

handler Error {ErrCode {Description "Unknown"}} {
	if {![string equal 0:1 $ErrCode]} {
		MessageDlg .z -icon error -type ok\
			-message "ERROR $ErrCode\n$Description"
	}	
}

proc LoadIcons {subpath iconset} {
	foreach el $iconset { foreach dir $::DATA {
		set f [file join $dir $subpath ${el}.gif]
		if [file exists $f] { 
			image create photo img:$el -file $f
			continue
		}
	}}
}	

LoadIcons icons {away dnd ffc group invisible message na occ offline online url}

DefaultTheme

Module tree.tcl
Module dialogs.tcl
Module hideoffline.tcl
Module hideempty.tcl
Module viewlog.tcl
Module menu.tcl
Module tkonfig.tcl
switch $::tcl_platform(platform) {
	unix {Module unix.tcl}
}
#bind Alicq <Destroy> {Event Exit}

