#  Alicq ICQ client: encoding module
#  Copyright (C) Ihar Viarheichyk 2001

#  This module is a part of Alicq ICQ client.

proc GetEncoding {} {
	# Default value is system encoding
	set encoding [encoding system]
	# Use encodings beginnig with CP on the wire
	if {[string match cp* $encoding]} {return $encoding}
	# Trying find wire encoding by the list
	foreach {local wire} {{koi8-r koi8-u iso8859-5} cp1251} {
		if {[lsearch -exact $local $encoding]!=-1} {
			return $wire 
		}
	}
	# If previuos attempts failed, analyse LANG variable
	# (usefull for UTF-8 encoding
	if {[info exists ::env(LANG)]} {
		switch -regex $::env(LANG) {
			"^(be|ru|ua)_" 	{set encoding "cp1251" }
		}
	}
	return $encoding
}

proc SetEncodings {args} {
	foreach p [lsprop Contact:ICQ:*|encoding] {
		icq::SetEncoding [pget $p]\
			[lindex [split [lindex [split $p |] 0] :] 2]
	}
}

set encoding [GetEncoding]
set values [map x [encoding names] {set _ [string index $x 0]:$x}]

property Contact:ICQ:*|encoding [list -type variant -name Encoding\
	-values $values -default $encoding -save change]
property Global:ICQ:Info|Encoding [list -type variant -values $values\
	-default $encoding]

#pset Global:ICQ:Info|Encoding $encoding

after idle [namespace code {
	SetEncodings
	handler Contact:ICQ:*|encoding {id oldval newval} {
		set uin [lindex [split [lindex [split $id |] 0] :] 2]
		icq::SetEncoding $newval $uin
	}
}]

