# This module allows hide offline contacts if needed
# Requires: tree.tcl
#
# Author: Ihar Viarheichyk

namespace eval ::tree::empty {
	handler Global:UI:Tree|HideEmpty {id old new} {
		if {[string is true $new]} {
		   tree::filter 50Empty {
	    		if {[string match Group:* $uid]&&\
			    ![llength [pget $uid|children]]} return {}
		   }
		   handler Group:*|children {id old new} {
			if {![llength $old] || ![llength $new]} {
				set uid [lindex [split $id |] 0]
				pset $uid|groups [tree::Grouper $uid]
			}
		   } ChildrenChanged 
		} else {
		   tree::filter 51Empty {}
		   unhook Group:*|children ChildrenChanged
		}
		foreach x [lsprop Group:*|Alias] {
			set uid [lindex [split $x |] 0]
			pset $uid|groups [::tree::Grouper $uid]
		}
	}
	property::Add Global:UI:Tree|HideEmpty {
		-type boolean -default 0 
		-scope {mainmenu configurator}
		-name {Interface:Hide empty groups} -save exit
	}
	bind . <<Hide-Empty>> {
		set val	[expr [string is true [pget Global:UI:Tree|HideEmpty]]^1]
		pset Global:UI:Tree|HideEmpty $val
	}
}
