# This module allows hide offline contacts if needed
# Requires: tree.tcl
#
# Author: Ihar Viarheichyk

namespace eval ::tree::offline {
	handler Global:UI:Tree|HideOffline {id old new} {
		if {[string is true $new]} {
		   tree::filter 50Offline {
	   		if {[string match Contact:* $uid]&&\
			    [pget $uid|Status]=={offline}} return {}
		   }
		   handler Contact:*|Status {id old new} {
			if {$old=={offline}||$new=={offline}} {
				set uid [lindex [split $id |] 0]
				pset $uid|groups [tree::Grouper $uid]
			}
		   } StatusChanged 
		} else {
		   tree::filter 50Offline {}
		   unhook Contact:*|Status StatusChanged 
		}
		foreach x [lsprop Contact:*|Alias] {
			set uid [lindex [split $x |] 0]
			if {[pget $uid|Status]=={offline}} {
				pset $uid|groups [::tree::Grouper $uid]
			}
		}
	}

	property::Add Global:UI:Tree|HideOffline {
		-type boolean -default 0 
		-scope {mainmenu configurator}
		-name {Interface:Hide offline contacts} -save exit}

	bind . <<Hide-Offline>> {
		set val	[expr [string is true [pget Global:UI:Tree|HideOffline]]^1]
		pset Global:UI:Tree|HideOffline $val
	}
}
