variable base [file join $::BASE history]

# Get from history
handler HistoryRequest {uin} {
	variable base
	if {[catch {
		set fd [open [file join $base ${uin}.history]]
		set h [read $fd]
		close $fd
	}]} return	
	regsub -all {\n\[ ([RS]) \|[^]]*\| (\d+) \]\n} [string map\
		{"\\" "\\\\" "\{" "\\\{" "\}" "\\\}"} $h] "\} \\1 \\2 \{\r" h
	regsub -all {^\[ ([RS]) \|[^]]*\| (\d+) \]\n} $h "\\1 \\2 \{\r" h
	append h "\}"
	FeedHistory $uin [lrange $h end-152 end]
	return
}
proc FeedHistory {uin list} {
	Event HistoryItem $uin [expr {[string equal [string trim [lindex $list 0]] R]?"incoming":"outgoing"}] [lindex $list 1] [string map {"\n:" "\n" "\r:" {} "\\\}" "\}" "\\\{" "\{"} [lindex $list 2]]
	if {[llength [set list [lrange $list 3 end]]]} {
		after idle [nc FeedHistory $uin $list]
	}	
}

# Save message to history
proc Message {type UIN time Message} {
	variable base
	catch {
		set fd [open [file join $base $UIN.history] a+]
		puts $fd "\[ $type | 0001 | 0270 | 0000 | $time \]"
		foreach ln [split $Message \n] { puts $fd ":$ln" }
		close $fd
	}
}

if {![file exists $base]} {file mkdir $base}

hook IncomingMessage {Message R}
hook OutgoingMessage {Message S}
