handler CreateContextMenu {menumask menu} {
	CreateMenu $menu [map y [grep x [lsmeta] {
			[string match [lindex [split $x |] 0] $menumask]
		}] {set z $menumask|[lindex [split $y |] 1];pget $z; set z }]
}

proc CreateMainMenu {menu} {
	CreateMenu $menu [grep x [lsmeta] {[string match Global\[:|\]* $x]}]
}

proc CreateMenu {menuname menuitems} {
	if {[winfo exists $menuname]} { destroy $menuname }
	menu $menuname -type normal -tearoff no

	foreach item [lsort -command weightsort $menuitems] {
		foreach {id name} [split $item |] break
		if {[property::exists $item -name]} {
			set l [split [property::meta $item -name] :]
			set menu [ui::subcascade $menuname [lrange $l 0 end-1]]
			set label [lindex $l end]
			switch -glob [property::meta $item -type] {
				boolean { 
					$menu add checkbutton -label $label -onvalue 1 -offvalue 0 -variable [property::Variable $item]}
				action 	{ $menu add command -label $label  -command "Event $item $item" }
				string { 
					$menu add command -label $label -command "::ui::menu::string $item $label" }
				variant {
					$menu add cascade -label $label -menu [ui::menu::variant $menu.mn${item} [property::Variable $item] [property::meta $item -values]]
				}
			}
		}
	}
}

proc weightsort {key1 key2} {
	eval string compare [map key [list $key1 $key2] {
		expr {[property::exists $key -weight]?\
		      [property::meta $key -weight]:90} }]
}

handler ConfigLoaded {} {
	CreateMainMenu .main.m
	handler ModuleLoaded {module} {CreateMainMenu .main.m} 99Module
} 99Config
