# This is a simple sample of URL handler
# This module is a part of Alicq ICQ client
#
# Author: Ihar Viarheichyk

property::Add	Global:UI:Url|*-regexp	{-type string}
property::Add	Global:UI:Url|*-handler	{-type string -default {xterm -e lynx %0 &}}

# Take into account BROWSER environment variable
if [info exists env(BROWSER)] {
	pset Global:UI:Url|http-handler "{$env(BROWSER) %0}"
}

# Default protocol regexps
# %0 %1 %2 ets substituted to all regexp contents, first parentses connetns, 
# second parentses contents etc respectively
foreach {proto exp} {	http 	{http://[^ ]+}   ftp	{ftp://[^ ]+}
			default {URL:\s*[^ ]+}} {
	pset Global:UI:Url|$proto-regexp $exp		
}

proc UrlHandler {txt} {
	set URL [eval $txt get [$txt tag prevrange url current]]
	foreach item [lsprop Global:UI:Url|*-regexp] {
		set rg [regexp -inline -- [pget $item] $URL]
		if {![llength $rg]} continue
		set handler [pget [lindex [split $item -] 0]-handler]
		set subst 0
		foreach item $rg {
			regsub -all -- "%$subst" $handler $item handler
			incr subst
		}
	}
	eval exec $handler
}
handler InitDisplayFilter {txt} {
	$txt tag configure url -foreground blue -underline yes
	set cursor [$txt cget -cursor]
	$txt tag bind url <Enter> "$txt configure -cursor hand2" 
	$txt tag bind url <1> [nc UrlHandler $txt]
	$txt tag bind url <Leave> "$txt configure -cursor $cursor" 
}
handler DisplayFilter {txt idx1 idx2} {
	foreach item [lsprop Global:UI:Url|*-regexp] {
		set i1 $idx1
		set i2 $idx2
		while {[set i1 [$txt search -count len -regexp [pget $item] $i1 $i2]]!={}} {
			$txt tag add url $i1 "$i1 + $len char"
			set i1 [$txt index "$i1 + $len char"]			
		}	
	}		
}
