# This module is used to view Alicq log messages in Alicq.
# it is part of Alicq instant messenger client
# 
# Author: Ihar Viarheichyk

handler {Global:Actions|viewlog} {args} {
	set top .log
	if [catch {toplevel $top}] return
	set cmd "destroy $top"
	pack [ScrolledTxt $top.log] -expand yes -fill both
	pack [ButtonBar $top.btn [list [list Close $cmd <Escape>]]]
	set fd [open $::LOGNAME]
	while {[gets $fd ln]!=-1} { $top.log.txt insert end "$ln\n" }
	close $fd
	$top.log.txt see end
	$top.log.txt configure -state disabled
	hook ViewLog "Update $top"
	bind $top <Destroy> [namespace code {
		if {[winfo toplevel %W]=={%W}} {unhook ViewLog * }
	}]
}
proc Update {top str} {
	$top.log.txt configure -state normal
	$top.log.txt insert end "$str\n"
	$top.log.txt see end
	$top.log.txt configure -state disabled
	#update
}

property::Add Global:Actions|viewlog {-type action -weight 95 -name {View log} -hook ViewLog}
