# This module is used to create and update WidowMaker dock icon
# It is a part of Alicq instant messenger client
#
# Author: Ihar Viarheichyk

handler MyStatus {status args} {
	.icon.c itemconfigure text -text $status
	.icon.c itemconfigure icon -image img:$status
}
proc ShowHide {} {
	wm state . [expr ([string equal [wm state .] normal])?"withdrawn":"normal"]
}

proc GetMessages {} {
	set lst [grep x [lsprop Contact:*|Pending] {[llength [pget $x]]}]
	if {[llength $lst]} {
		set uid [lindex [split [lindex $lst 0] |] 0]
		Event $uid|Send:Message $uid|Send:Message
	}
}

proc CreateIcon {} {
	if {[wm iconwindow .]==""} {
		toplevel .icon
		wm iconwindow . .icon
	}
	wm command . [file join [pwd] $::argv0]
	canvas .icon.c -background black -width 52 -height 52 -relief sunken
	.icon.c create image 26 26 -anchor s -image img:offline -tag icon
	.icon.c create text 26 52 -anchor s\
		-text [pget Global:ICQ:Info|Status] -fill white -tag text
	pack .icon.c
	bind .icon.c <1> {.main.m unpost}
	.icon.c bind icon <1> [nc GetMessages]
	.icon.c bind icon <3> {.status.m post %X %Y}
	.icon.c bind text <1> [nc ShowHide]
	.icon.c bind text <3> {.main.m post %X %Y}
}

handler Flashing {stage} {
	.icon.c itemconfigure icon -image\
		img:[expr {$stage?[pget Global:ICQ:Info|Status]:{message}}]
}

# Hide window instead of deletion
wm protocol . WM_DELETE_WINDOW {wm withdraw .}

CreateIcon
